/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: tagTYPEDESCPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the tagTYPEDESCPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=tagTYPEDESC.class)
public class tagTYPEDESCPointer extends StructurePointer {

	// NULL
	public static final tagTYPEDESCPointer NULL = new tagTYPEDESCPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected tagTYPEDESCPointer(long address) {
		super(address);
	}

	public static tagTYPEDESCPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static tagTYPEDESCPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static tagTYPEDESCPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new tagTYPEDESCPointer(address);
	}

	public tagTYPEDESCPointer add(long count) {
		return tagTYPEDESCPointer.cast(address + (tagTYPEDESC.SIZEOF * count));
	}

	public tagTYPEDESCPointer add(Scalar count) {
		return add(count.longValue());
	}

	public tagTYPEDESCPointer addOffset(long offset) {
		return tagTYPEDESCPointer.cast(address + offset);
	}

	public tagTYPEDESCPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public tagTYPEDESCPointer sub(long count) {
		return tagTYPEDESCPointer.cast(address - (tagTYPEDESC.SIZEOF * count));
	}

	public tagTYPEDESCPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public tagTYPEDESCPointer subOffset(long offset) {
		return tagTYPEDESCPointer.cast(address - offset);
	}

	public tagTYPEDESCPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public tagTYPEDESCPointer untag(long mask) {
		return tagTYPEDESCPointer.cast(address & ~mask);
	}

	public tagTYPEDESCPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return tagTYPEDESC.SIZEOF;
	}

	// Implementation methods

	// U32 hreftype
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_hreftypeOffset_", declaredType="U32")
	public UDATA hreftype() throws CorruptDataException {
		return new U32(getIntAtOffset(tagTYPEDESC._hreftypeOffset_));
	}

	// U32 hreftype
	public UDATAPointer hreftypeEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(tagTYPEDESC._hreftypeOffset_));
	}

	// tagARRAYDESC* lpadesc
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lpadescOffset_", declaredType="tagARRAYDESC*")
	public tagARRAYDESCPointer lpadesc() throws CorruptDataException {
		return tagARRAYDESCPointer.cast(getPointerAtOffset(tagTYPEDESC._lpadescOffset_));
	}

	// tagARRAYDESC* lpadesc
	public PointerPointer lpadescEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(tagTYPEDESC._lpadescOffset_));
	}

	// tagTYPEDESC* lptdesc
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_lptdescOffset_", declaredType="tagTYPEDESC*")
	public tagTYPEDESCPointer lptdesc() throws CorruptDataException {
		return tagTYPEDESCPointer.cast(getPointerAtOffset(tagTYPEDESC._lptdescOffset_));
	}

	// tagTYPEDESC* lptdesc
	public PointerPointer lptdescEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(tagTYPEDESC._lptdescOffset_));
	}

	// U16 vt
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_vtOffset_", declaredType="U16")
	public U16 vt() throws CorruptDataException {
		return new U16(getShortAtOffset(tagTYPEDESC._vtOffset_));
	}

	// U16 vt
	public U16Pointer vtEA() throws CorruptDataException {
		return U16Pointer.cast(nonNullFieldEA(tagTYPEDESC._vtOffset_));
	}

}
